<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//if ( !class_exists('WPsite_Firebar_Admin_Functions') ) :

// AJAX call for laoding stats and email data

add_action( 'wp_ajax_wps_fb_stats_load', 					array('WPsite_Firebar_Admin_Functions', 'stats_load'));
add_action( 'wp_ajax_wps_fb_emails_load', 					array('WPsite_Firebar_Admin_Functions', 'emails_load'));

// AJAX call to get all tags and custom posts

add_action( 'wp_ajax_wps_fb_get_categories', 				array('WPsite_Firebar_Admin_Functions', 'get_categories'));
add_action( 'wp_ajax_wps_fb_get_tags', 						array('WPsite_Firebar_Admin_Functions', 'get_tags'));
add_action( 'wp_ajax_wps_fb_get_posts', 					array('WPsite_Firebar_Admin_Functions', 'get_posts'));

// AJAX call for loading MailChimp and Aweber List Data

add_action( 'wp_ajax_wps_fb_get_mailchimp_lists', 			array('WPsite_Firebar_Admin_Functions', 'get_mailchimp_lists'));
add_action( 'wp_ajax_wps_fb_get_aweber_lists', 				array('WPsite_Firebar_Admin_Functions', 'get_aweber_lists'));
add_action( 'wp_ajax_wps_fb_get_getresponse_lists', 		array('WPsite_Firebar_Admin_Functions', 'get_getresponse_lists'));
add_action( 'wp_ajax_wps_fb_get_campaignmonitor_lists', 	array('WPsite_Firebar_Admin_Functions', 'get_campaignmonitor_lists'));
add_action( 'wp_ajax_wps_fb_update_campaignmonitor_lists', 	array('WPsite_Firebar_Admin_Functions', 'update_campaignmonitor_lists'));
add_action( 'wp_ajax_wps_fb_get_madmimi_lists', 			array('WPsite_Firebar_Admin_Functions', 'get_madmimi_lists'));

// Cron Jobs

add_action( 'initialize_firebar_stats_daily_cron', 			array('WPsite_Firebar_Admin_Functions', 'initialize_firebar_stats_daily'), 10 ,2 );
add_action( 'setup_firebar_email_stats_cron', 				array('WPsite_Firebar_Admin_Functions', 'setup_firebar_email_stats'), 10 ,2 );

// Miscellaneous

add_action( 'wp_ajax_wps_fb_send_weekly_email', 			array('WPsite_Firebar_Admin_Functions', 'send_weekly_email'));

/**
 *
 * Main class for all admin functions
 *
 * @since 1.2.5
 */
class WPsite_Firebar_Admin_Functions {

	/**
	 * Returns a default Firebar in array format
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_firebar(){
		return array(
			'id' 			=> '',
			'name' 			=> '',
			'title'			=> __('Create FireBars that display the right message at the right time', WPsite_Firebar::$text_domain),
			'template' 		=> 'News Letter',
			'location' 		=> 'Top',
			'display' 		=> 'Bar',
			'color' 		=> '#ef5f00',
			'text_color' 	=> '#fff',
			'trigger' 		=> array(
				'type'		=> 'site'
			),
			'height' 		=> '40',
			'link_url' 		=> 'http://wpsite.net',
			'link_name' 	=> __('Click Here!', WPsite_Firebar::$text_domain),
			'text_link' 	=> array(
				'link_type'			=> 'button',
				'link_target'		=> '_blank',
				'link_rel'			=> '',
				'link_text_color'	=> '#ffffff',
				'link_button_color'	=> '#000000'
			),
			'social' => array(
				'link_type'		=> 'flat',
				'icons'			=> array(
					array('type' => 'fa-facebook', 'url' => 'https://www.facebook.com/WPsite'),
					array('type' => 'fa-google-plus', 'url' => 'https://plus.google.com/106771475441130344412/posts'),
					array('type' => 'fa-twitter', 'url' => 'https://twitter.com/WPsite'),
					array('type' => 'fa-linkedin', 'url' => 'http://linkedin.com/company/wpsite'),
					array('type' => 'fa-youtube', 'url' => 'http://youtube.com/wpsitenet/'),
					array('type' => 'fa-reddit', 'url' => 'http://reddit.com/u/wpsite'),
					array('type' => 'fa-instagram', 'url' => 'http://instagram.com/wpsite'),
					array('type' => 'fa-pinterest', 'url' => 'http://pinterest.com/wpsite/'),
				),
			),
			'news_letter' => array(
				'type' 				=> 'WordPress',
				'first_name'		=> true,
				'last_name'			=> true,
				'button_text'		=> __('Subscribe', WPsite_Firebar::$text_domain),
				'success_action'	=> 'message',
				'success_url'		=> '',
				'success_message'	=> __('We will be in touch soon!', WPsite_Firebar::$text_domain),
				'MailChimp' 	=> array(
					'url' 		=> '',
					'api_key'	=> '',
					'list'		=> '',
					'optin'		=> true,
				),
				'aweber' => array(
					'consumer_key' 		=> '',
					'consumer_secret' 	=> '',
					'access_key' 		=> '',
					'access_secret' 	=> '',
					'account_id' 		=> '',
					'list_id' 			=> ''
				),
				'getresponse'	=> array(
					'api_key' 		=> '',
					'campaign'		=> '',
				),
				'campaignmonitor'	=> array(
					'api_key'			=> '',
					'client' 			=> '',
					'list'				=> '',
				),
				'madmimi'	=> array(
					'api_key'			=> '',
					'username' 			=> '',
					'list'				=> '',
				),
				'feedburner' => array(
					'id'	=> 'wpsite'
				)
			),
			'custom' 	=> '',
			'active' 	=> 'Active',
			'animation'	=> 'yes',
			'args'		=> array(
				'recent_posts'		=> array(
					'tag'			=> '',
					'count'			=> '',
				),
				'twitter'			=> array(
					'count'			=> '5',
					'api_key'		=> '',
					'api_secret'	=> '',
					'token'			=> '',
					'token_secret'	=> '',
				),
				'users'				=> 'any',
				'user_roles'		=> array(),
				'referrer_type'		=> 'any',
				'referrer'			=> 't.co,www.facebook.com,plus.url.google.com,www.linkedin.com',
				'stub_location'		=> 'right',
				'stub_shape'		=> 'drop',
				'icon_color'		=> '#000000',
				'border_color'		=> '#000000',
				'position'			=> 'fixed',
				'effect'			=> 'blind',
				'border_size'		=> '1',
				'start_date'		=> null,
				'end_date'			=> null,
				'move_body'			=> 'yes',
				'mobile'			=> 'yes',
				'font_size'			=> '14',
				'font_weight'		=> 'bold',
				'font_family'		=> 'Arial, Helvetica, sans-serif',
				'google_fonts'		=> false,
				'icon'				=> 'glyphicon-fire',
				'nl_text_color'		=> '#ffffff',
				'nl_button_color'	=> '#1e73be',
				'shadow'			=> 'yes',
			)
		);
	}

	/**
	 * Default settings for all optin fires
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_global_settings() {
		return array(
			'send_weekly_email'	=> true,
		);
	}

	/**
	 * Save all the user inputted for the given Firebar
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function save_data() {

		global $wp_roles;

		// Get all post types

		$post_types = get_post_types(array('public' => true));

		// Get default values for Firebar

		$default_firebar = self::default_firebar();
		$val = array();

		$val['name']          = stripslashes(sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'name']));

		$val['title']         = isset($_POST[WPsite_Firebar::$prefix_dash . 'title']) ?
								stripslashes(sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'title'])) :
								$default_firebar['title'];

		$val['template']      = isset($_POST[WPsite_Firebar::$prefix_dash . 'template']) ?
								$_POST[WPsite_Firebar::$prefix_dash . 'template'] :
								$default_firebar['template'];

		$val['location']      = isset($_POST[WPsite_Firebar::$prefix_dash . 'location']) ?
								$_POST[WPsite_Firebar::$prefix_dash . 'location'] :
								$default_firebar['location'];

		$val['display']       = isset($_POST[WPsite_Firebar::$prefix_dash . 'display']) ?
								$_POST[WPsite_Firebar::$prefix_dash . 'display'] :
								$default_firebar['display'];

		$val['color']         = isset($_POST[WPsite_Firebar::$prefix_dash . 'color']) ?
								sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'color']) :
								$default_firebar['color'];

		$val['text_color']    = isset($_POST[WPsite_Firebar::$prefix_dash . 'text-color']) ?
								sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'text-color']) :
								$default_firebar['text_color'];

		$val['height']        = isset($_POST[WPsite_Firebar::$prefix_dash . 'height']) ?
								(int) sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'height']) :
								$default_firebar['height'];

		$val['height']        = $val['height'] >= 40 ? $val['height'] : 40;

		$val['active']        = isset($_POST[WPsite_Firebar::$prefix_dash . 'active']) ?
								$_POST[WPsite_Firebar::$prefix_dash . 'active'] :
								$default_firebar['active'];

		$val['animation']     = isset($_POST[WPsite_Firebar::$prefix_dash . 'animation']) &&
								$_POST[WPsite_Firebar::$prefix_dash . 'animation'] ? 'yes' : 'no';

		// Args

		$val['args']['stub_location']             = isset($_POST[WPsite_Firebar::$prefix_dash . 'stub-location']) ?
													$_POST[WPsite_Firebar::$prefix_dash . 'stub-location'] : 'right';

		$val['args']['stub_shape']                = isset($_POST[WPsite_Firebar::$prefix_dash . 'stub-shape']) ?
													$_POST[WPsite_Firebar::$prefix_dash . 'stub-shape'] : 'drop';

		$val['args']['icon_color']                = isset($_POST[WPsite_Firebar::$prefix_dash . 'icon-color']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'icon-color']) :
													$default_firebar['args']['icon_color'];

		$val['args']['border_color']              = isset($_POST[WPsite_Firebar::$prefix_dash . 'border-color']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'border-color']) :
													$default_firebar['args']['border_color'];

		$val['args']['position']                  = isset($_POST[WPsite_Firebar::$prefix_dash . 'position']) ?
													$_POST[WPsite_Firebar::$prefix_dash . 'position'] :
													$default_firebar['args']['position'];

		$val['args']['effect']                    = isset($_POST[WPsite_Firebar::$prefix_dash . 'effect']) ?
													$_POST[WPsite_Firebar::$prefix_dash . 'effect'] :
													$default_firebar['args']['effect'];

		$val['args']['border_size']               = isset($_POST[WPsite_Firebar::$prefix_dash . 'border-size']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'border-size']) :
													$default_firebar['args']['border_size'];

		$val['args']['move_body']                 = isset($_POST[WPsite_Firebar::$prefix_dash . 'move-body']) &&
													$_POST[WPsite_Firebar::$prefix_dash . 'move-body'] ? 'yes' : 'no';

		$val['args']['mobile']                    = isset($_POST[WPsite_Firebar::$prefix_dash . 'mobile']) &&
													$_POST[WPsite_Firebar::$prefix_dash . 'mobile'] ? 'yes' : 'no';

		$val['args']['font_size']                 = isset($_POST[WPsite_Firebar::$prefix_dash . 'font-size']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'font-size']) :
													$default_firebar['args']['font_size'];

		$val['args']['font_weight']               = isset($_POST[WPsite_Firebar::$prefix_dash . 'font-weight']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'font-weight']) :
													$default_firebar['args']['font_weight'];

		$val['args']['font_family']               = isset($_POST[WPsite_Firebar::$prefix_dash . 'font-family']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'font-family']) :
													$default_firebar['args']['font_family'];

		$val['args']['google_fonts']               = isset($_POST[WPsite_Firebar::$prefix_dash . 'google-fonts']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'google-fonts']) :
													$default_firebar['args']['google_fonts'];

		$val['args']['start_date']                = isset($_POST[WPsite_Firebar::$prefix_dash . 'start-date']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'start-date']) :
													date("m/d/Y");

		$val['args']['end_date']                  = isset($_POST[WPsite_Firebar::$prefix_dash . 'end-date']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'end-date']) :
													date("m/d/Y", mktime(0, 0, 0, date("m"), date("d"), date("Y")+20));

		$val['args']['icon']                      = isset($_POST[WPsite_Firebar::$prefix_dash . 'icon']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'icon']) :
													$default_firebar['args']['icon'];

		$val['args']['nl_text_color']             = isset($_POST[WPsite_Firebar::$prefix_dash . 'newsletter-text-color']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'newsletter-text-color']) :
													$default_firebar['args']['nl_text_color'];

		$val['args']['nl_button_color']           = isset($_POST[WPsite_Firebar::$prefix_dash . 'newsletter-button-color']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'newsletter-button-color']) :
													$default_firebar['args']['nl_button_color'];

		$val['args']['shadow']                    = isset($_POST[WPsite_Firebar::$prefix_dash . 'shadow']) &&
													$_POST[WPsite_Firebar::$prefix_dash . 'shadow'] ? 'yes' : 'no';

		$val['args']['recent_posts']['tag']       = isset($_POST[WPsite_Firebar::$prefix_dash . 'recent-posts-tag']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'recent-posts-tag']) : '';

		$val['args']['recent_posts']['count']     = isset($_POST[WPsite_Firebar::$prefix_dash . 'recent-posts-count']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'recent-posts-count']) :
													$default_firebar['args']['recent_posts']['count'];

		$val['args']['twitter']['count']          = isset($_POST[WPsite_Firebar::$prefix_dash . 'twitter-count']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'twitter-count']) :
													$default_firebar['args']['twitter']['count'];

		$val['args']['twitter']['api_key']        = isset($_POST[WPsite_Firebar::$prefix_dash . 'twitter-api-key']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'twitter-api-key']) : '';

		$val['args']['twitter']['api_secret']     = isset($_POST[WPsite_Firebar::$prefix_dash . 'twitter-api-secret']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'twitter-api-secret']) : '';

		$val['args']['twitter']['token']          = isset($_POST[WPsite_Firebar::$prefix_dash . 'twitter-token']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'twitter-token']) : '';

		$val['args']['twitter']['token_secret']   = isset($_POST[WPsite_Firebar::$prefix_dash . 'twitter-token-secret']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'twitter-token-secret']) : '';

	    // Users

	    $val['args']['users']                     = isset($_POST[WPsite_Firebar::$prefix_dash . 'args-users']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'args-users']) :
													$default_firebar['args']['users'];

		foreach ($wp_roles->role_names as $role_name => $role) {
			$val['args']['user_roles'][$role_name] = isset($_POST[WPsite_Firebar::$prefix_dash . 'args-role-' . $role_name]) && $_POST[WPsite_Firebar::$prefix_dash . 'args-role-' . $role_name] ? true : false;
		}

		// Referrer Type

		$val['args']['referrer_type']  			  = isset($_POST[WPsite_Firebar::$prefix_dash . 'args-referrer-type']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'args-referrer-type']) :
													$default_firebar['args']['referrer_type'];

		$val['args']['referrer']       			  = isset($_POST[WPsite_Firebar::$prefix_dash . 'args-referrer']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'args-referrer']) :
													$default_firebar['args']['referrer'];

		// Trigger

		$val['trigger']['type']               = isset($_POST[WPsite_Firebar::$prefix_dash . 'trigger-type']) ?
												$_POST[WPsite_Firebar::$prefix_dash . 'trigger-type'] :
												$default_firebar['trigger']['type'];

		$val['trigger']['category']['all']    = isset($_POST[WPsite_Firebar::$prefix_dash . 'trigger-category-all']) ?
												$_POST[WPsite_Firebar::$prefix_dash . 'trigger-category-all'] : false;

		$val['trigger']['category']['id']     = isset($_POST[WPsite_Firebar::$prefix_dash . 'trigger-category-id']) ?
												str_replace(' ', '', rtrim(sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'trigger-category-id']), ',')) : '';

		$val['trigger']['tag']['id']          = isset($_POST[WPsite_Firebar::$prefix_dash . 'trigger-tag-id']) ?
												str_replace(' ', '', rtrim(sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'trigger-tag-id']), ',')) : '';

		foreach ($post_types as $post_type) {

			$val['trigger'][$post_type]['all']   = isset($_POST[WPsite_Firebar::$prefix_dash . 'trigger-all-' . $post_type]) ?
													$_POST[WPsite_Firebar::$prefix_dash . 'trigger-all-' . $post_type] : false;

			$val['trigger'][$post_type]['id']    = isset($_POST[WPsite_Firebar::$prefix_dash . 'trigger-id-' . $post_type]) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'trigger-id-' . $post_type]) : false;

			$val['trigger'][$post_type]['exclude'] 	= isset($_POST[WPsite_Firebar::$prefix_dash . 'trigger-exclude-' . $post_type]) ?
												      str_replace(' ', '', rtrim(sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'trigger-exclude-' . $post_type]), ',')) : '';

		}

		// Text and Link

		$val['link_url']                          = isset($_POST[WPsite_Firebar::$prefix_dash . 'link-url']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'link-url']) :
													$default_firebar['link_url'];

		$val['link_name']                         = isset($_POST[WPsite_Firebar::$prefix_dash . 'link-name']) ?
													stripslashes(sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'link-name'])) :
													$default_firebar['link_name'];

		$val['text_link']['link_type']            = isset($_POST[WPsite_Firebar::$prefix_dash . 'link-type']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'link-type']) :
													$default_firebar['text_link']['link_type'];

		$val['text_link']['link_target']          = isset($_POST[WPsite_Firebar::$prefix_dash . 'link-target']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'link-target']) :
													$default_firebar['text_link']['link_target'];

		$val['text_link']['link_rel']             = isset($_POST[WPsite_Firebar::$prefix_dash . 'link-rel']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'link-rel']) :
													$default_firebar['text_link']['link_rel'];

		$val['text_link']['link_text_color']      = isset($_POST[WPsite_Firebar::$prefix_dash . 'link-text-color']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'link-text-color']) :
													$default_firebar['text_link']['link_text_color'];

		$val['text_link']['link_button_color']    = isset($_POST[WPsite_Firebar::$prefix_dash . 'link-button-color']) ?
													sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'link-button-color']) :
													$default_firebar['text_link']['link_button_color'];

		// Social

		$val['social']['link_type']	  = isset($_POST[WPsite_Firebar::$prefix_dash . 'social-link-type']) ?
										sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'social-link-type']) :
										$default_firebar['social']['link_type'];

		$social_type              	  = isset($_POST[WPsite_Firebar::$prefix_dash . 'social-type']) ?
										$_POST[WPsite_Firebar::$prefix_dash . 'social-type'] : '';

		$social_url               	  = isset($_POST[WPsite_Firebar::$prefix_dash . 'social-url']) ?
										$_POST[WPsite_Firebar::$prefix_dash . 'social-url'] : '';

		$social_media_icons = array();

		for ($i = 0; $i < count($social_type); $i++) {

			if (isset($social_type[$i]) && $social_type[$i] != '' && $social_url[$i] != '') {
				$social_media_icons[] = array(
					'type' 	=> sanitize_text_field($social_type[$i]),
					'url' 	=> sanitize_text_field($social_url[$i])
				);
			}
		}

		$val['social']['icons'] = $social_media_icons;


		// News Letter

		$val['news_letter']['type']                       = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-type']) ?
															$_POST[WPsite_Firebar::$prefix_dash . 'news-letter-type'] :
															$default_firebar['news_letter']['type'];

		$val['news_letter']['first_name']                 = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-first-name']) &&
															$_POST[WPsite_Firebar::$prefix_dash . 'news-letter-first-name'] ? true : false;

		$val['news_letter']['last_name']                  = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-last-name']) &&
															$_POST[WPsite_Firebar::$prefix_dash . 'news-letter-last-name'] ? true : false;

		$val['news_letter']['success_action']             = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-success-action']) ?
															$_POST[WPsite_Firebar::$prefix_dash . 'news-letter-success-action'] :
															$default_firebar['news_letter']['success_action'];

		$val['news_letter']['success_url']                = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-success-url']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-success-url']) :
															$default_firebar['news_letter']['success_url'];

		$val['news_letter']['success_message']            = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-success-message']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-success-message']) :
															$default_firebar['news_letter']['success_message'];

		$val['news_letter']['button_text']                = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-button-text']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-button-text']) :
															$default_firebar['news_letter']['button_text'];

		// MailChimp

		$val['news_letter']['MailChimp']['url']           = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-url']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-url']) :
															$default_firebar['news_letter']['MailChimp']['url'];

		$val['news_letter']['MailChimp']['api_key']       = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-api-key']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-api-key']) :
															$default_firebar['news_letter']['MailChimp']['api_key'];

		$val['news_letter']['MailChimp']['list']          = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-list']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-list']) :
															$default_firebar['news_letter']['MailChimp']['list'];

		$val['news_letter']['MailChimp']['optin']         = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-optin']) &&
															$_POST[WPsite_Firebar::$prefix_dash . 'news-letter-MailChimp-optin'] ? true : false;

		// Aweber

		$val['news_letter']['aweber']['consumer_key']     = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-consumer-key']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-consumer-key']) :
															$default_firebar['news_letter']['aweber']['consumer_key'];

		$val['news_letter']['aweber']['consumer_secret']  = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-consumer-secret']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-consumer-secret']) :
															$default_firebar['news_letter']['aweber']['consumer_secret'];

		$val['news_letter']['aweber']['access_key']       = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-access-key']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-access-key']) :
															$default_firebar['news_letter']['aweber']['access_key'];

		$val['news_letter']['aweber']['access_secret']    = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-access-secret']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-access-secret']) :
															$default_firebar['news_letter']['aweber']['access_secret'];

		$val['news_letter']['aweber']['account_id']       = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-account-id']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-account-id']) :
															$default_firebar['news_letter']['aweber']['account_id'];

		$val['news_letter']['aweber']['list_id']          = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-list-id']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-aweber-list-id']) :
															$default_firebar['news_letter']['aweber']['list_id'];

		// Get Response

		$val['news_letter']['getresponse']['api_key']             = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-getresponse-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-getresponse-api-key']) :
																	$default_firebar['news_letter']['getresponse']['api_key'];

		$val['news_letter']['getresponse']['campaign']            = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-getresponse-campaign']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-getresponse-campaign']) :
																	$default_firebar['news_letter']['getresponse']['campaign'];

		// Campiagn Monitor

		$val['news_letter']['campaignmonitor']['api_key']         = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-campaignmonitor-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-campaignmonitor-api-key']) :
																	$default_firebar['news_letter']['campaignmonitor']['api_key'];

		$val['news_letter']['campaignmonitor']['client']          = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-campaignmonitor-client']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-campaignmonitor-client']) :
																	$default_firebar['news_letter']['campaignmonitor']['client'];

		$val['news_letter']['campaignmonitor']['list']            = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-campaignmonitor-list']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-campaignmonitor-list']) :
																	$default_firebar['news_letter']['campaignmonitor']['list'];

		// Mad Mimi

		$val['news_letter']['madmimi']['api_key']                 = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-madmimi-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-madmimi-api-key']) :
																	$default_firebar['news_letter']['madmimi']['api_key'];

		$val['news_letter']['madmimi']['username']                = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-madmimi-username']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-madmimi-username']) :
																	$default_firebar['news_letter']['madmimi']['username'];

		$val['news_letter']['madmimi']['list']                    = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-madmimi-list']) ?
																	sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-madmimi-list']) :
																	$default_firebar['news_letter']['madmimi']['list'];

		// feedburner

		$val['news_letter']['feedburner']['id']           = isset($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-feedburner-id']) ?
															sanitize_text_field($_POST[WPsite_Firebar::$prefix_dash . 'news-letter-feedburner-id']) :
															$default_firebar['aweber']['feedburner']['id'];

		// Custom

		$val['custom']                                    = isset($_POST[WPsite_Firebar::$prefix_dash . 'custom']) ?
															stripcslashes($_POST[WPsite_Firebar::$prefix_dash . 'custom']) :
															$default_firebar['custom'];

		return $val;

	}

	/**
	 * Load all stats using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats_load() {

		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/admin/model/db.php");
		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/core/model/stats.php");

		// Get Stats

		$start_date = date(WPSITE_FIREBAR_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime($post_end_date));
		}

		global $wpdb;

		// All firebar stats

		if (isset($_POST['firebar_name']) && $_POST['firebar_name'] == '') {

			$stats = WPsite_Stats_FB::getStats($start_date, $end_date);

			$firebars = $wpdb->get_results("SELECT * FROM `" . WPsite_Firebar_DB::getTableName() . "`");

			$firebar_stats = array();

			foreach ($firebars as $firebar) {
				foreach ($stats as $stat) {
					if ($firebar->id == $stat['firebar_id']) {
						$firebar_stats[$firebar->id] = array(
							'firebar_id'	=> $stat['firebar_id'],
							'firebar_name'	=> $firebar->name,
							'firebar_type'	=> $firebar->template,
							'date'			=> $stat['date'],
							'impressions'	=> isset($firebar_stats[$firebar->id]['impressions']) ? $firebar_stats[$firebar->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
							'clicks'	=> isset($firebar_stats[$firebar->id]['clicks']) ? $firebar_stats[$firebar->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
						);
					}
				}
			}

			$impressions_total = 0;
			$clicks_total = 0;
			foreach ($firebar_stats as $firebar_stat) {
			    $impressions_total += $firebar_stat['impressions'];
			    $clicks_total += $firebar_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($clicks_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . WPsite_Firebar::$prefix_dash . 'stats-total-container well col-xs-12">
				<div class="' . WPsite_Firebar::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Impressions', WPsite_Firebar::$text_domain) . '</span><br/>
					<span class="' . WPsite_Firebar::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</span><br/>
				</div>
				<div class="' . WPsite_Firebar::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Clicks', WPsite_Firebar::$text_domain) . '</span><br/>
					<span class="' . WPsite_Firebar::$prefix_dash . 'stats-totals-text">' . number_format($clicks_total) . '</span><br/>
				</div>
				<div class="' . WPsite_Firebar::$prefix_dash . 'stats-totals col-xs-4">
					<span>' .  __('Click-Through-Rate', WPsite_Firebar::$text_domain) . '</span><br/>
					<span class="' . WPsite_Firebar::$prefix_dash . 'stats-totals-text">' . $ctr . '%</span><br/>
				</div>
			</div>

			<div style="clear:both"></div>

			<canvas id="' . WPsite_Firebar::$prefix_dash . 'line-graph"></canvas>

			<div class="table-responsive">
				<table class="table table-condensed table-striped">

					<thead>
						<th>' . __('Firebar', WPsite_Firebar::$text_domain) . '</th>
						<th class="' . WPsite_Firebar::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-globe"></span> ' . __('Impressions', WPsite_Firebar::$text_domain) . '</th>
						<th class="' . WPsite_Firebar::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Clicks', WPsite_Firebar::$text_domain) . '</th>
						<th>' . __('Click-Through-Rate', WPsite_Firebar::$text_domain) . '</th>
					</thead>';

					foreach ($firebar_stats as $firebar_stat) {

						$stats_content .= '<tr>
							<td>
								<a href="' . admin_url() . 'admin.php?page=' . WPsite_Firebar::$stats_page . '&firebar_id=' . $firebar_stat['firebar_id'] . '&firebar_name=' . $firebar_stat['firebar_name'] . '" role="button" class="btn btn-xs btn-primary">
									' .  $firebar_stat['firebar_name'] . '
								</a>
							</td>
							<td>' . number_format($firebar_stat['impressions']) . '</td>';

							if ($firebar_stat['firebar_type'] == 'Text') {
								$stats_content .= '
								<td>' . __('N/A', WPsite_Firebar::$text_domain) . '</td>
								<td>' . __('N/A', WPsite_Firebar::$text_domain) . '</td>';
							} else {
								$stats_content .= '
								<td>' . number_format($firebar_stat['clicks']) . '</td>
								<td>' . ($firebar_stat['impressions'] > 0 ? round(($firebar_stat['clicks'] / $firebar_stat['impressions']) * 100, 2) : '0') . '%</td>';
							}

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		// Single firebar stats

		else if (isset($_POST['firebar_name']) && $_POST['firebar_name'] != '') {

			$firebar_stats = WPsite_Stats_FB::getStats($start_date, $end_date, $_POST['firebar_id']);

			$firebars = $wpdb->get_results("SELECT * FROM `" . WPsite_Firebar_DB::getTableName() . "`");

			foreach ($firebars as $firebar) {
				foreach ($firebar_stats as $key => $firebar_stat) {
					if ($firebar->id == $firebar_stat['firebar_id']) {
						$firebar_stats[$key] = array('firebar_name' => $firebar->name) + $firebar_stats[$key] + array('firebar_type' => $firebar->template);
					}
				}
			}

			// Unset indexs

			foreach ($firebar_stats as $key => $firebar_stat) {
				unset($firebar_stats[$key]['id']);
				unset($firebar_stats[$key]['firebar_id']);
			}

			$impressions_total = 0;
			$clicks_total = 0;
			foreach ($firebar_stats as $firebar_stat) {
			    $impressions_total += $firebar_stat['impressions'];
			    $clicks_total += $firebar_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($clicks_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . WPsite_Firebar::$prefix_dash . 'stats-total-container well col-xs-12">
				<div class="' . WPsite_Firebar::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Impressions', WPsite_Firebar::$text_domain) . '</span><br/>
					<span class="' . WPsite_Firebar::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</span><br/>
				</div>
				<div class="' . WPsite_Firebar::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Clicks', WPsite_Firebar::$text_domain) . '</span><br/>
					<span class="' . WPsite_Firebar::$prefix_dash . 'stats-totals-text">' . number_format($clicks_total) . '</span><br/>
				</div>
				<div class="' . WPsite_Firebar::$prefix_dash . 'stats-totals col-xs-4">
					<span>' .  __('Click-Through-Rate', WPsite_Firebar::$text_domain) . '</span><br/>
					<span class="' . WPsite_Firebar::$prefix_dash . 'stats-totals-text">' . $ctr . '%</span><br/>
				</div>
			</div>

			<div style="clear:both"></div>

			<canvas id="' . WPsite_Firebar::$prefix_dash . 'line-graph"></canvas>

			<div class="table-responsive">
				<table class="table table-condensed table-striped">

					<thead>
						<th>' . __('Date', WPsite_Firebar::$text_domain) . '</th>
						<th class="' . WPsite_Firebar::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Impressions', WPsite_Firebar::$text_domain) . '</th>
						<th class="' . WPsite_Firebar::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Clicks', WPsite_Firebar::$text_domain) . '</th>
						<th>' . __('Click-Through-Rate', WPsite_Firebar::$text_domain) . '</th>
					</thead>';

					foreach (array_reverse($firebar_stats) as $firebar_stat) {

						$stats_content .= '<tr>
							<td>' . date('M j Y', strtotime($firebar_stat['date'])) . '</td>
							<td>' . number_format($firebar_stat['impressions']) . '</td>';

							if ($firebar_stat['firebar_type'] == 'Text') {
								$stats_content .= '
								<td>' . __('N/A', WPsite_Firebar::$text_domain) . '</td>
								<td>' . __('N/A', WPsite_Firebar::$text_domain) . '</td>';
							} else {
								$stats_content .= '
								<td>' . number_format($firebar_stat['clicks']) . '</td>
								<td>' . ($firebar_stat['impressions'] > 0 ? round(($firebar_stat['clicks'] / $firebar_stat['impressions']) * 100, 2) : '0') . '%</td>';
							}

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		echo json_encode(array('stats_content' => $stats_content, 'firebar_stats' => $firebar_stats));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function emails_load() {

		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/admin/model/db.php");
		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/core/model/email-signups.php");

		// Get Start and End Dates

		$start_date = date(WPSITE_FIREBAR_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime($post_end_date));
		}

		// Get Emails

		global $wpdb;

		$emails = WPsite_Email_Signups_FB::getEmails($start_date, $end_date);
		$firebars = $wpdb->get_results("SELECT * FROM `" . WPsite_Firebar_DB::getTableName() . "`");

		foreach ($emails as $key => $email) {
			$emails[$key]['firebar_name'] = '<strong style="color:red;">DELETED</strong>';
		}

		foreach ($firebars as $firebar) {
			foreach ($emails as $key => $email) {
				if ($firebar->id == $email['firebar_id']) {
					$emails[$key] = array(
						'firebar_id'	=> $email['firebar_id'],
						'firebar_name'	=> $firebar->name,
						'date'			=> $email['date'],
						'email'			=> $email['email'],
						'first_name'	=> $email['first_name'],
						'last_name'		=> $email['last_name'],
					);
				}
			}
		}

		$emails_content = '<div class="col-xs-12" style="padding-left: 0px; padding-right: 0px;">
			<table class="table table-condensed table-striped">

				<thead>
					<th>' . __('Date', WPsite_Firebar::$text_domain) . '</th>
					<th>' . __('Firebar Name', WPsite_Firebar::$text_domain) . '</th>
					<th>' . __('Email', WPsite_Firebar::$text_domain) . '</th>
					<th>' . __('First Name', WPsite_Firebar::$text_domain) . '</th>
					<th>' . __('Last Name', WPsite_Firebar::$text_domain) . '</th>
				</thead>';

				if (count($emails) < 1) {
					$emails_content .= '<tr>
						<td>' . __('No emails', WPsite_Firebar::$text_domain) . '</td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
					</tr>';
				} else {
					foreach (array_reverse($emails) as $firebar_email) {

						$emails_content .= '<tr>
							<td>' . $firebar_email['date'] . '</td>
							<td>' . $firebar_email['firebar_name'] . '</td>
							<td>' . $firebar_email['email'] . '</td>
							<td>' . $firebar_email['first_name'] . '</td>
							<td>' . $firebar_email['last_name'] . '</td>
						</tr>';

					}
				}

			$emails_content .= '</table>
		</div>';

		echo $emails_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Email the weekly Firebar Stats to the admin account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function setup_firebar_email_stats() {

		$global_settings = get_option(WPsite_Firebar::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if (!$global_settings['send_weekly_email']) {
			return false;
		}

		// Comment this out for testing

		if (date('N') != 7) {
			return false;
		}

		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/admin/model/db.php");
		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/core/model/stats.php");

		global $wpdb;

		$admins = get_users('role=administrator');

		$start_date = date(WPSITE_FIREBAR_DATE_FORMAT, mktime(0, 0, 0, date("m"), date("d")-7, date("Y")));
		$end_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime(current_time('mysql')));

		$stats = WPsite_Stats_FB::getStats($start_date, $end_date);
		$firebars = $wpdb->get_results("SELECT * FROM `" . WPsite_Firebar_DB::getTableName() . "`");
		$firebar_stats = array();

		foreach ($firebars as $firebar) {
			foreach ($stats as $stat) {
				if ($firebar->id == $stat['firebar_id']) {
					$firebar_stats[$firebar->id] = array(
						'firebar_id'	=> $stat['firebar_id'],
						'firebar_name'	=> $firebar->name,
						'firebar_type'	=> $firebar->template,
						'date'			=> $stat['date'],
						'impressions'	=> isset($firebar_stats[$firebar->id]['impressions']) ? $firebar_stats[$firebar->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
						'clicks'	=> isset($firebar_stats[$firebar->id]['clicks']) ? $firebar_stats[$firebar->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
					);
				}
			}
		}

		$impressions_total = 0;
		$clicks_total = 0;
		foreach ($firebar_stats as $firebar_stat) {
		    $impressions_total += $firebar_stat['impressions'];
		    $clicks_total += $firebar_stat['clicks'];
		}

		foreach ( $admins as $admin ) {

			$subject = __('Weekly Firebar Stats!', WPsite_Firebar::$text_domain);

			$head = '<html>
				<head></head>';

			$body = '<body>

					<img src="' . WPSITE_FIREBAR_PLUGIN_URL . '/img/rainbow-strip-hz-wide.png" style="width: 100%;"/>

					<h1>' . __('WPsite Firebar Weekly Stats', WPsite_Firebar::$text_domain) . '</h1>
					<h1>' . date('M j', strtotime($start_date)) . ' - ' . date('M j', strtotime($end_date)) . '</h1>

					<div style="min-height: 20px;
					  padding: 19px;
					  margin-bottom: 20px;
					  background-color: #f5f5f5;
					  border: 1px solid #e3e3e3;
					  border-radius: 4px;
					  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);
					          box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);">

						<table style="width:100%; border: none;">

							<col width="33.33%">
							<col width="33.33%">
							<col width="33.33%">

							<thead style="border: none;">
								<th style="border: none;">' . __('Impressions', WPsite_Firebar::$text_domain) . '</th>
								<th style="border: none;">' . __('Clicks', WPsite_Firebar::$text_domain) . '</th>
								<th style="border: none;">' .  __('Click-Through Rate', WPsite_Firebar::$text_domain) . '</th>
							</thead>

							<tr style="border: none;">
								<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($impressions_total) . '</td>
								<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($clicks_total) . '</td>
								<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . round(($clicks_total/$impressions_total) * 100,2) . '%</td>
							</tr>
						</table>

					</div>
					<table style="width: 100%;
					max-width: 100%;
					margin-bottom: 20px;">

						<thead style="border: 1px solid #ddd;">
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Firebar', WPsite_Firebar::$text_domain) . '</th>
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Impressions', WPsite_Firebar::$text_domain) . '</th>
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Clicks', WPsite_Firebar::$text_domain) . '</th>
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Click-Through-Rate', WPsite_Firebar::$text_domain) . '</th>
						</thead>';

						foreach ($firebar_stats as $firebar_stat) {

							$body .= '<tr style="border: 1px solid #ddd;text-align:center;">
								<td>
									<a style="
								  color: white;
								  text-decoration: none;
								  color: #fff;
								  cursor: pointer;
								display: inline-block;
								font-family: \'Helvetica Neue\', Helvetica, Arial, sans-serif;
								font-size: 12px;
								font-stretch: normal;
								font-style: normal;
								font-variant: normal;
								font-weight: normal;
								height: 18px;
								letter-spacing: normal;
								line-height: 18px;
								margin-bottom: 0px;
								margin-left: 0px;
								margin-right: 0px;
								margin-top: 0px;
								overflow-x: visible;
								overflow-y: visible;
								padding-bottom: 1px;
								padding-left: 5px;
								padding-right: 5px;
								padding-top: 1px;
								  background-color: #337ab7;
								  border-color: #2e6da4;
								  -webkit-border-radius: 3px;
								  -moz-border-radius: 3px;
								  border-radius: 3px;" href="' . admin_url() . 'admin.php?page=' . WPsite_Firebar::$stats_page . '&firebar_id=' . $firebar_stat['firebar_id'] . '&firebar_name=' . $firebar_stat['firebar_name'] . '" role="button" class="btn btn-xs btn-primary" style="color: white; text-decoration: none;">
										' .  $firebar_stat['firebar_name'] . '
									</a>
								</td>
								<td>' . number_format($firebar_stat['impressions']) . '</td>';

								if ($firebar_stat['firebar_type'] == 'Text') {
									$body .= '
									<td>' . __('N/A', WPsite_Firebar::$text_domain) . '</td>
									<td>' . __('N/A', WPsite_Firebar::$text_domain) . '</td>';
								} else {
									$body .= '
									<td>' . number_format($firebar_stat['clicks']) . '</td>
									<td>' . ($firebar_stat['impressions'] > 0 ? round(($firebar_stat['clicks'] / $firebar_stat['impressions']) * 100, 2) : '0') . '%</td>';
								}

							$body .= '</tr>';
						}

				$body .= '</table>
				</body>';

			$foot = '
				<br/>
				<br/>
				<br/>
				<p style="text-align: center;"><a href="http://wpsite.net">' . __('Visit', WPsite_Firebar::$text_domain) . '</a> ' . __('our site to read about all the latest WordPress News.', WPsite_Firebar::$text_domain) . '</p>
			</html>';

			$message = $head . $body . $foot;
			$headers = array('Content-Type: text/html; charset=UTF-8');

			$result = wp_mail($admin->user_email, $subject, $message, $headers);
		}
	}

	/**
	 * Everyday check if there is a record for impressions or clicks for each fireabr.
	 * If there is no record than add one and set it to 0..
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function initialize_firebar_stats_daily() {

		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/core/model/stats.php");

		WPsite_Stats_FB::initialize_firebar_stats();
	}

	/**
	 * Save the send weekly email setting
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function send_weekly_email() {

		$global_settings = get_option(WPsite_Firebar::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if ($_POST['send_weekly_email'] == 'true') {
			$global_settings['send_weekly_email'] = true;
		} else {
			$global_settings['send_weekly_email'] = false;
		}

		update_option(WPsite_Firebar::$prefix . 'global_settings', $global_settings);

		echo '';
		die();
	}

	/**
	 * Get all MailChimp Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mailchimp_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {
			require_once(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/mailchimp/MailChimp.php');

			$MailChimp = new WPS_MailChimp($_POST['api_key']);
			$lists = $MailChimp->call('lists/list');

			if (isset($lists) && is_array($lists)) {

				foreach ($lists['data'] as $list) {
					$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
				}

				if (isset($_POST['list']) && $_POST['list'] != '') {
					$options = '';
					foreach ($lists['data'] as $list) {

						if ($_POST['list'] == $list['id']) {
							$options .= '<option value="' . $list['id'] . '" selected="selected">' .  $list['name']. '</option>';
						} else {
							$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the Aweber lists for an account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_aweber_lists() {

		$options = '';
		$consumerKey = '';
		$consumerSecret = '';
		$accessKey = '';
		$accessSecret = '';

		if (isset($_POST['code']) && $_POST['code'] != '') {

			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/aweber/aweber_api.php');
			include_once(WPSITE_FIREBAR_PLUGIN_DIR . '/admin/model/db.php');

			try {
				$credentials = AWeberAPI::getDataFromAweberID($_POST['code']);
				list($consumerKey, $consumerSecret, $accessKey, $accessSecret) = $credentials;


				$consumerKey = isset($consumerKey) && !empty($consumerKey) ? $consumerKey : '';
				$consumerSecret = isset($consumerSecret) && !empty($consumerSecret) ? $consumerSecret : '';
				$accessKey = isset($accessKey) && !empty($accessKey) ? $accessKey : '';
				$accessSecret = isset($accessSecret) && !empty($accessSecret) ? $accessSecret : '';
			} catch (AWeberAPIException $exc) {
				error_log($exc);
			}

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				foreach ($lists as $list) {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		if (isset($_POST['list']) && $_POST['list'] != '') {

			$consumerKey     = $_POST['consumer_key'];
			$consumerSecret  = $_POST['consumer_secret'];
			$accessKey       = $_POST['access_key'];
			$accessSecret    = $_POST['access_secret'];

			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/aweber/aweber_api.php');
			include_once(WPSITE_FIREBAR_PLUGIN_DIR . '/admin/model/db.php');

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				$options = '';
				foreach ($lists as $list) {
					if ($_POST['list'] == $list->id) {
						$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
					} else {
						$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
					}
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		echo json_encode(array(
			'html'               => $options,
			'consumer_key'       => $consumerKey,
			'consumer_secret'    => $consumerSecret,
			'access_key'         => $accessKey,
			'access_secret'      => $accessSecret,
		));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Get Repsonse Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_getresponse_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/getresponse/jsonRPCClient.php');
			$api = new jsonRPCClient('http://api2.getresponse.com');

			try {
				$result = $api->get_campaigns($_POST['api_key']);
				foreach ((array) $result as $k => $v) {
					$campaigns[] = array('id' => $k, 'name' => $v['name']);
				}
			}

			catch (Exception $e) {}

			if (isset($campaigns) && is_array($campaigns)) {

				foreach ($campaigns as $campaign) {
					$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
				}

				if (isset($_POST['campaign']) && $_POST['campaign'] != '') {
					$options = '';
					foreach ($campaigns as $campaign) {

						if ($_POST['campaign'] == $campaign['id']) {
							$options .= '<option value="' . $campaign['id'] . '" selected="selected">' .  $campaign['name'] . '</option>';
						} else {
							$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_campaignmonitor_lists() {

		$lists = '';
		$clients = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/campaignmonitor/csrest_general.php');
			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/campaignmonitor/csrest_clients.php');
			$auth = array('api_key' => $_POST['api_key']);
			$wrap = new CS_REST_General($auth);
			$result = $wrap->get_clients();


			if ($result->was_successful()) {

				foreach ($result->response as $client) {
					$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$clients = '';
					foreach ($result->response as $client) {
						if ($_POST['client'] == $client->ClientID) {
							$clients .= '<option value="' . $client->ClientID . '" selected="selected">' .  $client->Name . '</option>';
						} else {
							$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
						}
					}
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$client_id = $_POST['client'];
				} else {
					$client_id = $result->response[0]->ClientID;
				}

				$wrap = new CS_REST_Clients($client_id, $_POST['api_key']);
				$result = $wrap->get_lists();

				if ($result->was_successful()) {
					foreach ($result->response as $list) {
						$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
					}

					if (isset($_POST['list']) && $_POST['list'] != '') {
						$lists = '';
						foreach ($result->response as $list) {
							if ($_POST['list'] == $list->ListID) {
								$lists .= '<option value="' . $list->ListID . '" selected="selected">' .  $list->Name . '</option>';
							} else {
								$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
							}
						}
					}
				}
			}
		}

		echo json_encode(array('clients' => $clients, 'lists' => $lists));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Update all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function update_campaignmonitor_lists() {

		$lists = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['client_id']) && $_POST['client_id'] != '') {

			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/campaignmonitor/csrest_general.php');
			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/campaignmonitor/csrest_clients.php');


			$wrap = new CS_REST_Clients($_POST['client_id'], $_POST['api_key']);
			$result = $wrap->get_lists();


			if ($result->was_successful()) {
				foreach ($result->response as $list) {
					$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
				}
			}
		}

		echo $lists;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Mad Mimi Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_madmimi_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['username']) && $_POST['username'] != '') {

			require(WPSITE_FIREBAR_PLUGIN_DIR . '/core/includes/madmimi/MadMimi.class.php');

			$mailer = new MadMimi($_POST['username'], $_POST['api_key']);

			if (isset($mailer)) {
				try {
					$lists = $mailer->Lists();
					$lists  = new SimpleXMLElement($lists);

				    if ($lists->list) {
						foreach ($lists->list as $l) {
							$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
						}
				    }

				    if (isset($_POST['list']) && $_POST['list'] != '') {
					    $options = '';
						foreach ($lists->list as $l) {

							if ($_POST['list'] == $l->attributes()->{'name'}->{0}) {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '" selected="selected">' .  $l->attributes()->{'name'}->{0} . '</option>';
							} else {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
							}
						}
					}
				} catch (Exception $exc) {}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Posts in post type
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_posts() {

		echo json_encode(get_posts('posts_per_page=-1&post_type=' . $_POST['post_type']));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Categories
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_categories() {

		echo json_encode(get_categories());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Tags
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_tags() {

		echo json_encode(get_tags());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Mulit-byte Unserialize
	 *
	 * UTF-8 will screw up a serialized string
	 *
	 * @access private
	 * @param string
	 * @return string
	 */
	static function mb_unserialize($string) {
	    $string2 = preg_replace_callback(
	        '!s:(\d+):"(.*?)";!s',
	        function($m){
	            $len = strlen($m[2]);
	            $result = "s:$len:\"{$m[2]}\";";
	            return $result;

	        },
	        $string);
	    return unserialize($string2);
	}
}

//endif;